<?php

 // Data away (user stage executable file)

 // An expansion must start with this line
 defined('WM3_cEXEC') or die('Denied');

 require_once('data_away_lib.php');

 $userID   = $w3->getAuthenticateUserID();
 $action   = intval($w3->getVariable('action'));
 $download = intval($w3->getVariable('download'));

 // Submenu
 if($download == 0)
  {
   echo "&nbsp;"             . wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."&section=".$this->_CONFIG['id'],            "action_disable.png","","",$w3->getWordExpansion(5),0,16,16);
   echo "&nbsp;&nbsp;&nbsp;" . wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."&section=".$this->_CONFIG['id']."&action=1","action_disable.png","","",$w3->getWordExpansion(6),0,16,16);
   echo "&nbsp;&nbsp;&nbsp;" . wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."&section=".$this->_CONFIG['id']."&action=2","action_down.png",   "","",$w3->getWordExpansion(7),0,16,16) . "<br/><br/>";
  }

 if($action == 0)  // User personal data
  {
   $query = new wm3DBSelect("*",array('_users'),"userID = '$userID'");
   $rs  = $w3->getDBObj()->query($query);
   $row = $w3->getDBObj()->fetch($rs,false);
   $data = createUserDataArray($w3,$row);
   $list = new wm3GUIList($w3,$data,$w3->getWordExpansion(29));
   $list->setCaptionLabels(array('#',$w3->getWordExpansion(4)));
   $list->setCaptionWidths(array(25,75));
   echo $list->render() . '<br/>';
 }

 if($action == 1) // Data synthesis
  {
   $data = array(
            array($w3->getWordExpansion(10),totalForumPosts($w3,$userID)),
            array($w3->getWordExpansion(11),totalNews($w3,$userID)),
            array($w3->getWordExpansion(12),totalNews($w3,$userID,true)),
            array($w3->getWordExpansion(13),totalMessages($w3,$userID,'sended')),
            array($w3->getWordExpansion(14),totalMessages($w3,$userID)),
            array($w3->getWordExpansion(15),totalLogs($w3,$userID))
           );
   $list = new wm3GUIList($w3,$data,$w3->getWordExpansion(8));
   $list->setCaptionLabels(array('#',$w3->getWordExpansion(4)));   
   $list->setCaptionWidths(array(60,40));
   echo $list->render();
  }
 
 if($action == 2) // Download data
  {
   // Create a wm3GUIForm object
   $form_action = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."&section=".$this->_CONFIG['id']."&action=2";
   $form = new wm3GUIForm($w3,$form_action,$w3->getWordExpansion(7),'form_download');
   $form->setSubmitLabel($w3->getWordExpansion(7));
   $ck_personal = new wm3GUICheckBox('ck_personal',$w3->getVariable('ck_personal'),$w3->getWordExpansion(17),'disabled'); $ck_personal->setInactive(true);
   $ck_news     = new wm3GUICheckBox('ck_news',    $w3->getVariable('ck_news'),    $w3->getWordExpansion(18));
   $ck_forum    = new wm3GUICheckBox('ck_forum',   $w3->getVariable('ck_forum'),   $w3->getWordExpansion(19));
   $ck_msg      = new wm3GUICheckBox('ck_msg',     $w3->getVariable('ck_msg'),     $w3->getWordExpansion(20));
   $ck_log      = new wm3GUICheckBox('ck_log',     $w3->getVariable('ck_log'),     $w3->getWordExpansion(30));
   $format      = new wm3GUISelect  ('format',     $w3->getVariable('format'),     $w3->getWordExpansion(21),array(new wm3GUIOption('HTML','1')));
   //$format      = new wm3GUISelect  ('format',     $w3->getVariable('format'),     $w3->getWordExpansion(21),array(new wm3GUIOption('HTML','1'),new wm3GUIOption('XML','2')));
   $form->addField($ck_personal);
   $form->addField($ck_news);
   $form->addField($ck_forum);
   $form->addField($ck_msg);
   $form->addField($ck_log);
   $form->addField($format);
   $form->addField(new wm3GUIHiddenField('download','1'));

   if($form->wasSubmit())
    {
     $archive = WM3_cPATH_TEMP . md5(rand() . time()) . '.zip';
     $zip     = new ZipArchive();
     if($zip->open($archive,ZIPARCHIVE::CREATE) !== TRUE) { echo $w3->getWordExpansion(32); }
     else
      {
       // Personal data
       $query = new wm3DBSelect("*",array('_users'),"userID = '$userID'");
       $rs    = $w3->getDBObj()->query($query);
       $row   = $w3->getDBObj()->fetch($rs,false);
       $data  = createUserDataArray($w3,$row);
       $personal_data  = openHTML($w3->getWordExpansion(5));
       $personal_data .= openHTMLSection($w3->getWordExpansion(5),2);
       $i = 0; foreach($data as $key => $value) $personal_data .= createHTMLItem($i++,$value);
	   $personal_data .= closeHTMLSection();
       $personal_data .= closeHTML();
       $zip->addFromString("personal_data.html",$personal_data);
       
	   // News data
       if($w3->getVariable('ck_news'))
        {
         $query = new wm3DBSelect("*",array('_news'),"userID = '$userID' ORDER BY ts");
         $rs    = $w3->getDBObj()->query($query);
         $data  = createUserNewsArray($w3,$rs);
         $news_data  = openHTML($w3->getWordExpansion(9));
         $news_data .= openHTMLSection($w3->getWordExpansion(9) . " (" .$w3->getWordExpansion(11) . ": " . totalNews($w3,$userID) . ")",4);
         $news_data .= createHTMLLabels(array("#",$w3->getWordExpansion(22),$w3->getWordExpansion(23),$w3->getWord(807)));
         $i = 0;
         foreach($data as $key => $value)
          {
		   $ln = (isset($_SERVER['HTTPS']) ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[SCRIPT_NAME]" . "?section=" . WM3_cSECTION_NEWS . "&newsID=" . $value[0] . "&action=" .WM3_cACTION_SHOW_SINGLE_NEWS;
		   $news_data .= createHTMLItem($i++,array("<a href=\"$ln\" target=\"_blank\">newsID:" . $value[0] . "</a><br/>categoryID:" . $value[1],$value[2],$value[3],$value[4])); 
	  	  }
	     $news_data .= closeHTMLSection(true);
         $query = new wm3DBSelect("*",array('_news_comments'),"userID = '$userID' ORDER BY ts");
         $rs    = $w3->getDBObj()->query($query);
         $data  = createUserNewsCommentsArray($w3,$rs);
         $news_data .= openHTMLSection($w3->getWordExpansion(25) . " (" .$w3->getWordExpansion(12) . ": " . totalNews($w3,$userID,true) . ")",4);
         $news_data .= createHTMLLabels(array("commentID:","newsID:",$w3->getWordExpansion(24),$w3->getWord(807)));
         $i = 0; foreach($data as $key => $value) $news_data .= createHTMLItem($i++,$value);
         $news_data .= closeHTMLSection();
         $news_data .= closeHTML();
         $zip->addFromString("news_data.html",$news_data);
        }
        
       // Forum data
       if($w3->getVariable('ck_forum'))
        {
         $query = new wm3DBSelect("*",array('_forums_posts'),"userID = '$userID' ORDER BY ts");
         $rs    = $w3->getDBObj()->query($query);
         $data  = createUserForumsPostArray($w3,$rs);
         $forum_data  = openHTML($w3->getWordExpansion(16));
         $forum_data .= openHTMLSection($w3->getWordExpansion(16). " (" . $w3->getWordExpansion(10) . ": " . totalForumPosts($w3,$userID) . ")",3);
         $forum_data .= createHTMLLabels(array("#",$w3->getWordExpansion(3),$w3->getWord(807)));
         $i = 0; foreach($data as $key => $value) $forum_data .= createHTMLItem($i++,array("forumID:" . $value[2] . "<br/>discussionID:" . $value[1] . "<br/>postID:" . $value[0],$value[3],$value[4]));
	     $forum_data .= closeHTMLSection();
         $forum_data .= closeHTML();
         $zip->addFromString("forum_data.html",$forum_data);
		}

       // Private message
       if($w3->getVariable('ck_msg'))
        {
         $query = new wm3DBSelect("*",array('_users_messages'),"toID = '$userID' OR fromID = '$userID' ORDER BY ts");
         $rs    = $w3->getDBObj()->query($query);
         $data  = createUserMessagesArray($w3,$rs);
         $messages_data  = openHTML($w3->getWordExpansion(27));
         $messages_data .= openHTMLSection($w3->getWordExpansion(27). " (" . $w3->getWordExpansion(26) . totalMessages($w3,$userID,'sended') . "/" . totalMessages($w3,$userID) . ")",4);
         $messages_data .= createHTMLLabels(array("#",$w3->getWordExpansion(28),$w3->getWordExpansion(23),$w3->getWord(807)));
         $i = 0;
         foreach($data as $key => $value)
          {
		   if($value[1] == $userID)                          $t = "[=>&nbsp;"  . $w3->getWordExpansion(33) . "]";
		   if($value[2] == $userID)                          $t = "[<=&nbsp;"  . $w3->getWordExpansion(34) . "]";
		   if($value[1] == $userID and $value[2] == $userID) $t = "[<=>&nbsp;" . $w3->getWordExpansion(35) . "]";
		   if($value[1] == 0)                                $t .= "<br/>["    . $w3->getWord(1249)        . "]";
		   $messages_data .= createHTMLItem($i++,array("messageID:" . $value[0] . "<br/>$t",$value[3],$value[4],$value[5])); 
	  	  }
	     $messages_data .= closeHTMLSection();
         $messages_data .= closeHTML();
         $zip->addFromString("messages_data.html",$messages_data);
		}

       // Generated logs
       if($w3->getVariable('ck_log'))
        {
         $query = new wm3DBSelect("*",array('_logs'),"userID = '$userID' ORDER BY ts DESC");
         $rs    = $w3->getDBObj()->query($query);
         $data  = createUserLogsArray($w3,$rs);
         $logs_data  = openHTML($w3->getWordExpansion(31));
         $logs_data .= openHTMLSection($w3->getWordExpansion(31). " (" . $w3->getWordExpansion(15) . ": " . totalLogs($w3,$userID) . ")",5);
         $logs_data .= createHTMLLabels(array("logID:","Referer:","IP:","DNS:",$w3->getWord(807)));
         $i = 0; foreach($data as $key => $value) $logs_data .= createHTMLItem($i++,$value);
	     $logs_data .= closeHTMLSection();
         $logs_data .= closeHTML();
         $zip->addFromString("logs_data.html",$logs_data);
		}

       $zip->close();
       $fname = userLogin($w3,$userID) . "_" . str_replace(' ','_',str_replace(':','.',wm3Util::renderDate($w3,time(),$w3->getHomeLanguage()) .'.zip'));    //$ts = wm3Util::renderDate($w3,$row['ts'],0,true mixed full, mixed msg, mixed time, mixed day)
       header("Content-type: application/zip"); 
       header("Content-Disposition: attachment; filename=$fname");
       header("Content-length: " . filesize($archive));
       header("Pragma: no-cache"); 
       header("Expires: 0"); 
       readfile($archive);
       unlink($archive);
       exit();
      }
    }
  else
    {
     // Form default values
     $ck_personal->setValue(WM3_cENABLED);
     $ck_news    ->setValue(WM3_cENABLED);
     $ck_forum   ->setValue(WM3_cENABLED);
     $ck_msg     ->setValue(WM3_cENABLED);
     $ck_log     ->setValue(WM3_cENABLED);
     echo $form->render();
    }
  }

?>
